Bug 869730

Summary: Agent loads Sigar with nonative flag activated
Product: [Other] RHQ Project Reporter: Stefan Negrea <snegrea>
Component: AgentAssignee: Stefan Negrea <snegrea>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: high Docs Contact:
Priority: unspecified    
Version: 4.5CC: hrupp, loleary
Target Milestone: ---   
Target Release: RHQ 4.6   
Hardware: All   
OS: All   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
: 870186 (view as bug list) Environment:
Last Closed: 2013-09-03 10:45:39 EDT Type: Bug
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On:    
Bug Blocks: 870186    

Description Stefan Negrea 2012-10-24 12:04:35 EDT
Description of problem:
Agent loads the Sigar library with nonative flag activated. This leads to errors agent startup failure in cases where the Sigar library is not compatible with the operating system.

How reproducible:
Every time

Steps to Reproduce:
1. Use a system that is not compatible with Sigar (eg. SUSE 10.1)
2. Run the agent with --nonative flag
3. Notice error
  
Actual results:
Failure to start with the following error:

#
# A fatal error has been detected by the Java Runtime Environment:
#
#  SIGFPE (0x8) at pc=0x00002b592b3d668f, pid=13696, tid=1074792768
#
# JRE version: 7.0_07-b10
# Java VM: Java HotSpot(TM) 64-Bit Server VM (23.3-b01 mixed mode linux-amd64 compressed oops)
# Problematic frame:
# C  [ld-linux-x86-64.so.2+0x868f]  do_lookup_x+0xcf
#
# Failed to write core dump. Core dumps have been disabled. To enable core dumping, try "ulimit -c unlimited" before starting Java again

Expected results:
The agent starts without Sigar loaded

Additional info:
This issue has been observed on Suse 10.x 64bit. This version of Suse is running an older glibc library (2.4.x) that should be compatible with Sigar but it is throwing SIGPFE excetion at startup. 

The main problem is that --nonative flag is not working properly as it should have prevented the loading of Sigar jars completely.
Comment 1 Stefan Negrea 2012-11-05 16:42:17 EST
Moved static block of code that was checking for Sigar availability to a static method. This allows correct usage of system properties and stored agent preferences at startup. With this change the agent will not load the Sigar library even if --nonative flag or rhq.agent.disable-native-system property are set to true.
Comment 3 Heiko W. Rupp 2013-09-03 10:45:39 EDT
Bulk closing of issues in old RHQ releases that are in production for a while now.

Please open a new issue when running into an issue.